=== added file '.bzrignore'
--- .bzrignore	1970-01-01 00:00:00 +0000
+++ .bzrignore	2009-02-05 16:47:23 +0000
@@ -0,0 +1,2 @@
+XRandR/XRandR.pidb
+.bzrignore

=== added directory 'XRandR'
=== added directory 'XRandR/Resources'
=== added file 'XRandR/Resources/XRandR.addin.xml'
--- XRandR/Resources/XRandR.addin.xml	1970-01-01 00:00:00 +0000
+++ XRandR/Resources/XRandR.addin.xml	2009-02-05 16:47:23 +0000
@@ -0,0 +1,22 @@
+<Addin
+	id="XRandR"
+	namespace="Do"
+	version="0.1"
+	name="XRandr"
+	description="Control the resolution of your X outputs."
+	author="Johannes Rudolph"
+	category="Community"
+	>
+
+	<Runtime>
+		<Import assembly="XRandR.dll"/>
+	</Runtime>
+
+	<Dependencies>
+		<Addin id="Universe" version="1.0" />
+	</Dependencies>
+
+	<Extension path = "/Do/ItemSource">
+		<ItemSource type="XRandR.XRandRItemSource" />
+	</Extension>
+</Addin>

=== added file 'XRandR/XRandR.mdp'
--- XRandR/XRandR.mdp	1970-01-01 00:00:00 +0000
+++ XRandR/XRandR.mdp	2009-02-05 16:47:23 +0000
@@ -0,0 +1,36 @@
+<Project name="XRandR" fileversion="2.0" language="C#" clr-version="Net_2_0" ctype="DotNetProject">
+  <Configurations active="Debug">
+    <Configuration name="Debug" ctype="DotNetProjectConfiguration">
+      <Output directory="bin/Debug" assembly="XRandR" />
+      <Build debugmode="True" target="Library" />
+      <Execution runwithwarnings="True" consolepause="False" runtime="MsNet" clr-version="Net_2_0" />
+      <CodeGeneration compiler="Mcs" warninglevel="4" optimize="True" unsafecodeallowed="False" generateoverflowchecks="True" definesymbols="DEBUG" generatexmldocumentation="False" ctype="CSharpCompilerParameters" />
+    </Configuration>
+    <Configuration name="Release" ctype="DotNetProjectConfiguration">
+      <Output directory="bin/Release" assembly="XRandR" />
+      <Build debugmode="False" target="Library" />
+      <Execution runwithwarnings="True" consolepause="False" runtime="MsNet" clr-version="Net_2_0" />
+      <CodeGeneration compiler="Mcs" warninglevel="4" optimize="True" unsafecodeallowed="False" generateoverflowchecks="True" generatexmldocumentation="False" ctype="CSharpCompilerParameters" />
+    </Configuration>
+  </Configurations>
+  <Contents>
+    <File name="gtk-gui/gui.stetic" subtype="Code" buildaction="EmbedAsResource" />
+    <File name="gtk-gui/generated.cs" subtype="Code" buildaction="Compile" />
+    <File name="src" subtype="Directory" buildaction="Compile" />
+    <File name="src/XRandrItemSource.cs" subtype="Code" buildaction="Compile" />
+    <File name="src/OutputItem.cs" subtype="Code" buildaction="Compile" />
+    <File name="Resources/XRandR.addin.xml" subtype="Code" buildaction="EmbedAsResource" />
+    <File name="src/Wrapper.cs" subtype="Code" buildaction="Compile" />
+  </Contents>
+  <References>
+    <ProjectReference type="Gac" localcopy="True" refto="System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" />
+    <ProjectReference type="Gac" localcopy="True" refto="gtk-sharp, Version=2.12.0.0, Culture=neutral, PublicKeyToken=35e10195dab3c99f" />
+    <ProjectReference type="Gac" localcopy="True" refto="gdk-sharp, Version=2.12.0.0, Culture=neutral, PublicKeyToken=35e10195dab3c99f" />
+    <ProjectReference type="Gac" localcopy="True" refto="Mono.Posix, Version=2.0.0.0, Culture=neutral, PublicKeyToken=0738eb9f132ed756" />
+    <ProjectReference type="Gac" localcopy="True" refto="Do.Platform.Linux, Version=0.9.0.0, Culture=neutral, PublicKeyToken=null" />
+    <ProjectReference type="Gac" localcopy="True" refto="Do.Universe, Version=0.9.0.0, Culture=neutral, PublicKeyToken=null" />
+    <ProjectReference type="Gac" localcopy="True" refto="Do.Platform, Version=0.9.0.0, Culture=neutral, PublicKeyToken=null" />
+    <ProjectReference type="Gac" localcopy="True" refto="Do.Interface.Linux, Version=0.9.0.0, Culture=neutral, PublicKeyToken=null" />
+  </References>
+  <GtkDesignInfo gtkVersion="2.12.1" />
+</Project>
\ No newline at end of file

=== added directory 'XRandR/gtk-gui'
=== added file 'XRandR/gtk-gui/generated.cs'
--- XRandR/gtk-gui/generated.cs	1970-01-01 00:00:00 +0000
+++ XRandR/gtk-gui/generated.cs	2009-02-05 16:47:23 +0000
@@ -0,0 +1,42 @@
+// ------------------------------------------------------------------------------
+//  <autogenerated>
+//      This code was generated by a tool.
+//      Mono Runtime Version: 2.0.50727.42
+// 
+//      Changes to this file may cause incorrect behavior and will be lost if 
+//      the code is regenerated.
+//  </autogenerated>
+// ------------------------------------------------------------------------------
+
+namespace Stetic {
+    
+    
+    internal class Gui {
+        
+        private static bool initialized;
+        
+        public static void Build(object cobj, System.Type type) {
+            Stetic.Gui.Build(cobj, type.FullName);
+        }
+        
+        public static void Build(object cobj, string id) {
+        }
+        
+        internal static void Initialize(Gtk.Widget iconRenderer) {
+            if ((Stetic.Gui.initialized == false)) {
+                Stetic.Gui.initialized = true;
+            }
+        }
+    }
+    
+    internal class ActionGroups {
+        
+        public static Gtk.ActionGroup GetActionGroup(System.Type type) {
+            return Stetic.ActionGroups.GetActionGroup(type.FullName);
+        }
+        
+        public static Gtk.ActionGroup GetActionGroup(string name) {
+            return null;
+        }
+    }
+}

=== added file 'XRandR/gtk-gui/gui.stetic'
--- XRandR/gtk-gui/gui.stetic	1970-01-01 00:00:00 +0000
+++ XRandR/gtk-gui/gui.stetic	2009-02-05 16:47:23 +0000
@@ -0,0 +1,7 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<stetic-interface>
+  <configuration>
+    <images-root-path>..</images-root-path>
+    <target-gtk-version>2.12.1</target-gtk-version>
+  </configuration>
+</stetic-interface>
\ No newline at end of file

=== added directory 'XRandR/src'
=== added file 'XRandR/src/OutputItem.cs'
--- XRandR/src/OutputItem.cs	1970-01-01 00:00:00 +0000
+++ XRandR/src/OutputItem.cs	2009-02-05 16:47:23 +0000
@@ -0,0 +1,33 @@
+// OutputItem.cs created with MonoDevelop
+// User: johannes at 4:44 PM 2/4/2009
+//
+// To change standard headers go to Edit->Preferences->Coding->Standard Headers
+//
+
+using System;
+using Do.Universe;
+using Mono.Unix;
+
+namespace XRandR
+{
+	public class OutputItem : Item
+	{
+		String name;
+		public OutputItem(String name)
+		{
+			this.name = name;
+		}
+		
+		public override string Name {
+			get { return name; }
+		}
+		
+		public override string Description {
+			get { return Catalog.GetString ("Set your resolution"); }
+		}
+		
+		public override string Icon {
+			get { return "system-config-display"; }
+		}
+	}
+}

=== added file 'XRandR/src/Wrapper.cs'
--- XRandR/src/Wrapper.cs	1970-01-01 00:00:00 +0000
+++ XRandR/src/Wrapper.cs	2009-02-05 16:47:23 +0000
@@ -0,0 +1,105 @@
+// Wrapper.cs created with MonoDevelop
+// User: johannes at 5:01 PM 2/4/2009
+//
+// To change standard headers go to Edit->Preferences->Coding->Standard Headers
+//
+
+using System;
+using System.Runtime.InteropServices;
+using Window = System.IntPtr;
+using Display = System.IntPtr;
+
+namespace XRandR
+{
+	
+	
+	public class Wrapper
+	{
+		public static string[] OutputNames {
+			get{
+				IntPtr d = XOpenDisplay(null);
+				Console.WriteLine("Open display "+d);
+			
+				Window w = XRootWindow(d,0);
+				Console.WriteLine("root window: " + w);
+			
+				IntPtr res = XRRGetScreenResources(d,w);
+				Console.WriteLine("resources "+res);
+
+				XRRScreenResources res2 = (XRRScreenResources) Marshal.PtrToStructure(res,typeof(XRRScreenResources));
+			
+				Console.WriteLine("num outputs: "+res2.noutput);
+				Console.WriteLine("num crtcs: "+res2.ncrtc);
+				Console.WriteLine("num modes: "+res2.nmode);
+				Console.WriteLine("output 0: "+Marshal.ReadIntPtr(res2.outputs,0));
+			
+				string []names = new string[res2.noutput];
+				int i=0;
+				foreach(IntPtr output in PtrToArray(res2.outputs,res2.noutput))
+				{
+					IntPtr pinfo = XRRGetOutputInfo(d,res,output);
+					XRROutputInfo info = (XRROutputInfo) Marshal.PtrToStructure(pinfo,typeof(XRROutputInfo));
+					//Console.WriteLine("Name: "+info.name);
+					names[i]=info.name;
+					i++;
+				}			
+			
+				Console.WriteLine("Close display "+XCloseDisplay(d));
+				return names;
+			}
+		}
+		
+		public static IntPtr[] PtrToArray(IntPtr ptr,int numElements){
+			IntPtr[] res = new IntPtr[numElements];
+			for (int i=0;i<numElements;i++)
+				res[i] = Marshal.ReadIntPtr(ptr,IntPtr.Size * i);
+			return res;
+		}
+		
+		[DllImport("libX11")]
+		public static extern Display XOpenDisplay([MarshalAs(UnmanagedType.LPTStr)] string name);
+		[DllImport("libX11")]
+        public static extern int XCloseDisplay(Display display);
+		[DllImport("libX11")]
+		public static extern Window XRootWindow(Display d,int screen);
+		
+		[DllImport("libXrandr")]
+		public static extern IntPtr XRRGetScreenResources (Display dpy, Window window);
+		
+		[StructLayout (LayoutKind.Sequential)]
+		public struct XRRScreenResources{
+			int	timestamp;
+			int	configTimestamp;
+			public int		ncrtc;
+			IntPtr	crtcs;
+			public int		noutput;
+			public IntPtr   outputs;
+			public int		nmode;
+			IntPtr	modes;
+		}
+		
+		[DllImport("libXrandr")]
+		public static extern void XRRFreeScreenResources (IntPtr resources);
+
+		public struct XRROutputInfo {
+		    int	    timestamp;
+		    IntPtr	    crtc;
+		    public string	    name;
+		    int		    nameLen;
+		    long   mm_width;
+		    long   mm_height;
+		    IntPtr	    connection;
+		    IntPtr   subpixel_order;
+		    int		    ncrtc;
+		    IntPtr	    crtcs;
+		    int		    nclone;
+			IntPtr   	clones;
+		    int		    nmode;
+		    int		    npreferred;
+		    IntPtr	    modes;
+		};
+
+		[DllImport("libXrandr")]
+		public static extern IntPtr XRRGetOutputInfo (Display dpy, IntPtr resources, IntPtr output);
+	}
+}

=== added file 'XRandR/src/XRandrItemSource.cs'
--- XRandR/src/XRandrItemSource.cs	1970-01-01 00:00:00 +0000
+++ XRandR/src/XRandrItemSource.cs	2009-02-05 16:47:23 +0000
@@ -0,0 +1,54 @@
+// XRandrItemSource.cs created with MonoDevelop
+// User: johannes at 4:38 PM 2/4/2009
+//
+// To change standard headers go to Edit->Preferences->Coding->Standard Headers
+//
+
+using System;
+using Do.Universe;
+using System.Collections.Generic;
+using Mono.Unix;
+
+namespace XRandR
+{
+	public class XRandRItemSource : ItemSource
+	{
+		List<Item> items;
+
+		public XRandRItemSource ()
+		{
+			items = new List<Item> ();
+		}		
+		
+		public override string Name {
+			get { return Catalog.GetString ("Displays"); }
+		}
+		
+		public override string Description {
+			get { return Catalog.GetString ("Set your resolution"); }
+		}
+		
+		public override string Icon {
+			get { return "system-config-display"; }
+		}
+		
+		public override IEnumerable<Type> SupportedItemTypes {
+			get { return new Type [] {
+					typeof (OutputItem)
+				};
+			}
+		}
+		
+		public override IEnumerable<Item> Items {
+			get { return items; }
+		}
+
+		
+		public override void UpdateItems ()
+		{
+			items.Clear ();
+			foreach(string name in Wrapper.OutputNames)
+				items.Add (new OutputItem(name));
+		}
+	}
+}

